
;Original code by Poogo

.include "tn13adef.inc"
.equ clockpin = PB1		
.equ datapin  = PB2
.equ ledpin = PB0

.def tempreg = r16
.def clreg = r17
.def schet = r18
.def sl = r19

.def count0 = r21
.def count1 = r22
.def count2 = r23
.def flag = r24


.org 0x0000	rjmp main	;reset
.org 0x0001	reti		;int0
.org 0x0002	rjmp wait	;pcint0
.org 0x0003	reti		;tim0_ovf
.org 0x0004	reti		;ee_rdy
.org 0x0005	reti		;ana_comp
.org 0x0006	reti		;tim0_compa
.org 0x0007	reti		;tim0_compb
.org 0x0008	reti		;wdt
.org 0x0009	reti		;adt



main:	ldi tempreg, 0b00000101 
		out DDRB, tempreg			; PB2(data) , PB1(clock) , PB0(led) 
        ldi tempreg, 0b00000000
		out PORTB, tempreg			; 0  PB2(data), 0  PB1(clock), 0  PB0(led)

		ldi sl, 0b00110011			;    
		out MCUCR, sl
		ldi sl, 0b00100000
		out GIMSK, sl
		ldi sl, 0b00000010
		out PCMSK, sl
		sei

slp:	sleep
		nop
		nop
		rjmp slp


wait:	cli
		cbi PORTB, ledpin

		sbis PINB, clockpin	         ;     I/O 
		rjmp r
		sbi PORTB, ledpin
		clr clreg                    ; clreg
cltime:	sbis PINB, clockpin 	     ; 1  cloc
		rjmp clcol
		inc clreg
		nop
		nop
		nop
		nop
		nop
		rjmp cltime
clcol:	cpi clreg, 50				; clreg  100	
		brlo r;wait					;  
		cpi clreg, 83               ; clreg  190	
		brsh r;wait					;     ( )
		sbi PORTB, datapin			;    I/O
		clr tempreg					; tempreg
		clr schet					; schet

		ldi count0, 255				; 
		ldi count1, 255				;        
		ldi count2, 5				;        clock
		ldi flag, 0


		rjmp ltbl
r:		rjmp end
		
btwait:								; 1  cloc
		rcall timer					;  
		cpi flag, 0					;      
		brne r
		sbis PINB, clockpin         ;     I/O 
		rjmp btwait

		sbrs tempreg, 7				;     
		cbi PORTB, datapin			;    I/O
		sbrc tempreg, 7				;     
		sbi PORTB, datapin			;    I/O

wbt11:								; 0  cloc
		rcall timer
		cpi flag, 0
		brne r
		sbic PINB, clockpin 
		rjmp wbt11			

		
wbt12:	
		rcall timer
		cpi flag, 0
		brne r
		sbis PINB, clockpin	
		rjmp wbt12			

		sbrs tempreg, 6
		cbi PORTB, datapin
		sbrc tempreg, 6
		sbi PORTB, datapin

wbt21:	
		rcall timer
		cpi flag, 0
		brne r
		sbic PINB, clockpin ;????
		rjmp wbt21			;????
		
wbt22:	
		rcall timer
		cpi flag, 0
		brne r
		sbis PINB, clockpin	;???
		rjmp wbt22			;? ?????

		sbrs tempreg, 5
		cbi PORTB, datapin
		sbrc tempreg, 5
		sbi PORTB, datapin

wbt31:	
		rcall timer
		cpi flag, 0
		brne r
		sbic PINB, clockpin ;????
		rjmp wbt31			;????

wbt32:	
		rcall timer
		cpi flag, 0
		brne r
		sbis PINB, clockpin	;???
		rjmp wbt32			;? ?????

		sbrs tempreg, 4
		cbi PORTB, datapin
		sbrc tempreg, 4
		sbi PORTB, datapin		

wbt41:	
		rcall timer
		cpi flag, 0
		brne r
		sbic PINB, clockpin 
		rjmp wbt41

wbt42:	
		rcall timer
		cpi flag, 0
		brne r
		sbis PINB, clockpin
		rjmp wbt42

		sbrs tempreg, 3
		cbi PORTB, datapin
		sbrc tempreg, 3
		sbi PORTB, datapin	

wbt51:	
		rcall timer
		cpi flag, 0
		brne end
		sbic PINB, clockpin
		rjmp wbt51

wbt52:	
		rcall timer
		cpi flag, 0
		brne end
		sbis PINB, clockpin
		rjmp wbt52

		sbrs tempreg, 2
		cbi PORTB, datapin
		sbrc tempreg, 2
		sbi PORTB, datapin

wbt61:	
		rcall timer
		cpi flag, 0
		brne end
		sbic PINB, clockpin
		rjmp wbt61

wbt62:	
		rcall timer
		cpi flag, 0
		brne end
		sbis PINB, clockpin
		rjmp wbt62

		sbrs tempreg, 1
		cbi PORTB, datapin
		sbrc tempreg, 1
		sbi PORTB, datapin

wbt71:	
		rcall timer
		cpi flag, 0
		brne end
		sbic PINB, clockpin
		rjmp wbt71
		
wbt72:
		rcall timer
		cpi flag, 0
		brne end
		sbis PINB, clockpin
		rjmp wbt72

		sbrs tempreg, 0
		cbi PORTB, datapin
		sbrc tempreg, 0
		sbi PORTB, datapin

wbt01:	
		rcall timer
		cpi flag, 0
		brne end
		sbic PINB, clockpin
		rjmp wbt01

	;cbi PORTB, datapin

ltbl:	ldi ZH, High(ttbl<<1)
		ldi ZL, Low(ttbl)
		add	ZL, schet
		lsl ZL						;  
		lpm							;   
		mov tempreg, r0
		cpi schet, 23
		breq end					;  
		inc schet                  
		rjmp btwait
end:	
		nop
		nop
		nop
		nop
		cbi PORTB, datapin			;    I/O
		cbi PORTB, ledpin
		sei
		reti;rjmp wait		


timer:
		dec count0
		brne timerend
		dec count1
		brne timerend	
		dec count2
		brne timerend
		ldi flag,1
timerend:
		ret


.cseg
ttbl:	.db 0b11111101
		.db 0b10010111
		.db 0b00000011
		.db 0b10110111
		.db 0b10011011
		.db 0b11111111
		.db 0b11001101
		.db 0b11101111
		.db 0b00001010
		.db 0b10110000
		.db 0b11111110
		.db 0b10000001
		.db 0b00110010
		.db 0b00010001
		.db 0b00010101
		.db 0b11100101
		.db 0b11100101
		.db 0b11100101
		.db 0b11100101
		.db 0b01101101
		.db 0b01101101
		.db 0b01101101
		.db 0b01101101
